diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/class-wp-error.php ./wordpress-3.3/wp-includes/class-wp-error.php
*** ./wordpress-3.2.1/wp-includes/class-wp-error.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/class-wp-error.php	2011-09-03 11:02:41.000000000 -0500
***************
*** 70,76 ****
  	 * @since 2.1.0
  	 * @access public
  	 *
! 	 * @return array List of error codes, if avaiable.
  	 */
  	function get_error_codes() {
  		if ( empty($this->errors) )
--- 70,76 ----
  	 * @since 2.1.0
  	 * @access public
  	 *
! 	 * @return array List of error codes, if available.
  	 */
  	function get_error_codes() {
  		if ( empty($this->errors) )
***************
*** 102,108 ****
  	 * @since 2.1.0
  	 *
  	 * @param string|int $code Optional. Retrieve messages matching code, if exists.
! 	 * @return array Error strings on success, or empty array on failure (if using codee parameter).
  	 */
  	function get_error_messages($code = '') {
  		// Return all messages if no code specified.
--- 102,108 ----
  	 * @since 2.1.0
  	 *
  	 * @param string|int $code Optional. Retrieve messages matching code, if exists.
! 	 * @return array Error strings on success, or empty array on failure (if using code parameter).
  	 */
  	function get_error_messages($code = '') {
  		// Return all messages if no code specified.
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/class-wp.php ./wordpress-3.3/wp-includes/class-wp.php
*** ./wordpress-3.2.1/wp-includes/class-wp.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/class-wp.php	2011-11-14 15:05:13.000000000 -0600
***************
*** 185,238 ****
  
  			// Look for matches.
  			$request_match = $request;
! 			foreach ( (array) $rewrite as $match => $query) {
! 				// Don't try to match against AtomPub calls
! 				if ( $req_uri == 'wp-app.php' )
! 					break;
! 
! 				// If the requesting file is the anchor of the match, prepend it
! 				// to the path info.
! 				if ( (! empty($req_uri)) && (strpos($match, $req_uri) === 0) && ($req_uri != $request) )
! 					$request_match = $req_uri . '/' . $request;
! 
! 				if ( preg_match("#^$match#", $request_match, $matches) ||
! 					preg_match("#^$match#", urldecode($request_match), $matches) ) {
! 					// Got a match.
! 					$this->matched_rule = $match;
! 
! 					// Trim the query of everything up to the '?'.
! 					$query = preg_replace("!^.+\?!", '', $query);
! 
! 					// Substitute the substring matches into the query.
! 					$query = addslashes(WP_MatchesMapRegex::apply($query, $matches));
! 
! 					$this->matched_query = $query;
! 
! 					// Parse the query.
! 					parse_str($query, $perma_query_vars);
! 
! 					// If we're processing a 404 request, clear the error var
! 					// since we found something.
! 					if ( isset($_GET['error']) )
! 						unset($_GET['error']);
! 
! 					if ( isset($error) )
! 						unset($error);
  
! 					break;
  				}
  			}
  
  			// If req_uri is empty or if it is a request for ourself, unset error.
  			if ( empty($request) || $req_uri == $self || strpos($_SERVER['PHP_SELF'], 'wp-admin/') !== false ) {
! 				if ( isset($_GET['error']) )
! 					unset($_GET['error']);
! 
! 				if ( isset($error) )
! 					unset($error);
  
  				if ( isset($perma_query_vars) && strpos($_SERVER['PHP_SELF'], 'wp-admin/') !== false )
! 					unset($perma_query_vars);
  
  				$this->did_permalink = false;
  			}
--- 185,244 ----
  
  			// Look for matches.
  			$request_match = $request;
! 			if ( empty( $request_match ) ) {
! 				// An empty request could only match against ^$ regex
! 				if ( isset( $rewrite['$'] ) ) {
! 					$this->matched_rule = '$';
! 					$query = $rewrite['$'];
! 					$matches = array('');
! 				}
! 			} else if ( $req_uri != 'wp-app.php' ) {
! 				foreach ( (array) $rewrite as $match => $query ) {
! 					// If the requesting file is the anchor of the match, prepend it to the path info.
! 					if ( ! empty($req_uri) && strpos($match, $req_uri) === 0 && $req_uri != $request )
! 						$request_match = $req_uri . '/' . $request;
! 
! 					if ( preg_match("#^$match#", $request_match, $matches) ||
! 						preg_match("#^$match#", urldecode($request_match), $matches) ) {
! 
! 						if ( $wp_rewrite->use_verbose_page_rules && preg_match( '/pagename=\$matches\[([0-9]+)\]/', $query, $varmatch ) ) {
! 							// this is a verbose page match, lets check to be sure about it
! 							if ( ! get_page_by_path( $matches[ $varmatch[1] ] ) )
! 						 		continue;
! 						}
  
! 						// Got a match.
! 						$this->matched_rule = $match;
! 						break;
! 					}
  				}
  			}
  
+ 			if ( isset( $this->matched_rule ) ) {
+ 				// Trim the query of everything up to the '?'.
+ 				$query = preg_replace("!^.+\?!", '', $query);
+ 
+ 				// Substitute the substring matches into the query.
+ 				$query = addslashes(WP_MatchesMapRegex::apply($query, $matches));
+ 
+ 				$this->matched_query = $query;
+ 
+ 				// Parse the query.
+ 				parse_str($query, $perma_query_vars);
+ 
+ 				// If we're processing a 404 request, clear the error var
+ 				// since we found something.
+ 				unset( $_GET['error'] );
+ 				unset( $error );
+ 			}
+ 
  			// If req_uri is empty or if it is a request for ourself, unset error.
  			if ( empty($request) || $req_uri == $self || strpos($_SERVER['PHP_SELF'], 'wp-admin/') !== false ) {
! 				unset( $_GET['error'] );
! 				unset( $error );
  
  				if ( isset($perma_query_vars) && strpos($_SERVER['PHP_SELF'], 'wp-admin/') !== false )
! 					unset( $perma_query_vars );
  
  				$this->did_permalink = false;
  			}
***************
*** 563,573 ****
  	 *
  	 * @access public
  	 * @param string $subject subject
! 	 * @param array  $matches data used for subsitution
  	 * @return string
  	 */
! 	function apply($subject, $matches) {
! 		$oSelf =& new WP_MatchesMapRegex($subject, $matches);
  		return $oSelf->output;
  	}
  
--- 569,579 ----
  	 *
  	 * @access public
  	 * @param string $subject subject
! 	 * @param array  $matches data used for substitution
  	 * @return string
  	 */
! 	public static function apply($subject, $matches) {
! 		$oSelf = new WP_MatchesMapRegex($subject, $matches);
  		return $oSelf->output;
  	}
  
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/class.wp-scripts.php ./wordpress-3.3/wp-includes/class.wp-scripts.php
*** ./wordpress-3.2.1/wp-includes/class.wp-scripts.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/class.wp-scripts.php	2011-12-08 14:46:58.000000000 -0600
***************
*** 47,81 ****
  		return $this->do_items( $handles, $group );
  	}
  
  	function print_scripts_l10n( $handle, $echo = true ) {
! 		if ( empty($this->registered[$handle]->extra['l10n']) || empty($this->registered[$handle]->extra['l10n'][0]) || !is_array($this->registered[$handle]->extra['l10n'][1]) )
! 			return false;
  
! 		$object_name = $this->registered[$handle]->extra['l10n'][0];
  
! 		$data = "var $object_name = {\n";
! 		$eol = '';
! 		foreach ( $this->registered[$handle]->extra['l10n'][1] as $var => $val ) {
! 			if ( 'l10n_print_after' == $var ) {
! 				$after = $val;
! 				continue;
! 			}
! 			$data .= "$eol\t$var: \"" . esc_js( $val ) . '"';
! 			$eol = ",\n";
! 		}
! 		$data .= "\n};\n";
! 		$data .= isset($after) ? "$after\n" : '';
! 
! 		if ( $echo ) {
! 			echo "<script type='text/javascript'>\n";
! 			echo "/* <![CDATA[ */\n";
! 			echo $data;
! 			echo "/* ]]> */\n";
! 			echo "</script>\n";
! 			return true;
! 		} else {
! 			return $data;
! 		}
  	}
  
  	function do_item( $handle, $group = false ) {
--- 47,72 ----
  		return $this->do_items( $handles, $group );
  	}
  
+ 	// Deprecated since 3.3, see print_extra_script()
  	function print_scripts_l10n( $handle, $echo = true ) {
! 		_deprecated_function( __FUNCTION__, '3.3', 'print_extra_script()' );
! 		return $this->print_extra_script( $handle, $echo );
! 	}
  
! 	function print_extra_script( $handle, $echo = true ) {
! 		if ( !$output = $this->get_data( $handle, 'data' ) )
! 			return;
! 
! 		if ( !$echo )
! 			return $output;
! 
! 		echo "<script type='text/javascript'>\n"; // CDATA and type='text/javascript' is not needed for HTML 5
! 		echo "/* <![CDATA[ */\n";
! 		echo "$output\n";
! 		echo "/* ]]> */\n";
! 		echo "</script>\n";
  
! 		return true;
  	}
  
  	function do_item( $handle, $group = false ) {
***************
*** 103,109 ****
  		if ( $this->do_concat ) {
  			$srce = apply_filters( 'script_loader_src', $src, $handle );
  			if ( $this->in_default_dir($srce) ) {
! 				$this->print_code .= $this->print_scripts_l10n( $handle, false );
  				$this->concat .= "$handle,";
  				$this->concat_version .= "$handle$ver";
  				return true;
--- 94,100 ----
  		if ( $this->do_concat ) {
  			$srce = apply_filters( 'script_loader_src', $src, $handle );
  			if ( $this->in_default_dir($srce) ) {
! 				$this->print_code .= $this->print_extra_script( $handle, false );
  				$this->concat .= "$handle,";
  				$this->concat_version .= "$handle$ver";
  				return true;
***************
*** 113,126 ****
  			}
  		}
  
! 		$this->print_scripts_l10n( $handle );
  		if ( !preg_match('|^https?://|', $src) && ! ( $this->content_url && 0 === strpos($src, $this->content_url) ) ) {
  			$src = $this->base_url . $src;
  		}
  
  		if ( !empty($ver) )
  			$src = add_query_arg('ver', $ver, $src);
! 		$src = esc_url(apply_filters( 'script_loader_src', $src, $handle ));
  
  		if ( $this->do_concat )
  			$this->print_html .= "<script type='text/javascript' src='$src'></script>\n";
--- 104,118 ----
  			}
  		}
  
! 		$this->print_extra_script( $handle );
  		if ( !preg_match('|^https?://|', $src) && ! ( $this->content_url && 0 === strpos($src, $this->content_url) ) ) {
  			$src = $this->base_url . $src;
  		}
  
  		if ( !empty($ver) )
  			$src = add_query_arg('ver', $ver, $src);
! 
! 		$src = esc_url( apply_filters( 'script_loader_src', $src, $handle ) );
  
  		if ( $this->do_concat )
  			$this->print_html .= "<script type='text/javascript' src='$src'></script>\n";
***************
*** 133,153 ****
  	/**
  	 * Localizes a script
  	 *
! 	 * Localizes only if script has already been added
! 	 *
! 	 * @param string $handle Script name
! 	 * @param string $object_name Name of JS object to hold l10n info
! 	 * @param array $l10n Array of JS var name => localized string
! 	 * @return bool Successful localization
  	 */
  	function localize( $handle, $object_name, $l10n ) {
! 		if ( !$object_name || !$l10n )
! 			return false;
! 		return $this->add_data( $handle, 'l10n', array( $object_name, $l10n ) );
  	}
  
  	function set_group( $handle, $recursion, $group = false ) {
! 		$grp = isset($this->registered[$handle]->extra['group']) ? (int) $this->registered[$handle]->extra['group'] : 0;
  		if ( false !== $group && $grp > $group )
  			$grp = $group;
  
--- 125,165 ----
  	/**
  	 * Localizes a script
  	 *
! 	 * Localizes only if the script has already been added
  	 */
  	function localize( $handle, $object_name, $l10n ) {
! 		if ( is_array($l10n) && isset($l10n['l10n_print_after']) ) { // back compat, preserve the code in 'l10n_print_after' if present
! 			$after = $l10n['l10n_print_after'];
! 			unset($l10n['l10n_print_after']);
! 		}
! 
! 		foreach ( (array) $l10n as $key => $value ) {
! 			if ( !is_scalar($value) )
! 				continue;
! 
! 			$l10n[$key] = html_entity_decode( (string) $value, ENT_QUOTES, 'UTF-8');
! 		}
! 
! 		$script = "var $object_name = " . json_encode($l10n) . ';';
! 
! 		if ( !empty($after) )
! 			$script .= "\n$after";
! 
! 		$data = $this->get_data( $handle, 'data' );
! 
! 		if ( !empty( $data ) )
! 			$script = "$data;\n$script";
! 
! 		return $this->add_data( $handle, 'data', $script );
  	}
  
  	function set_group( $handle, $recursion, $group = false ) {
! 
! 		if ( $this->registered[$handle]->args === 1 )
! 			$grp = 1;
! 		else
! 			$grp = (int) $this->get_data( $handle, 'group' );
! 
  		if ( false !== $group && $grp > $group )
  			$grp = $group;
  
***************
*** 167,181 ****
  	}
  
  	function do_footer_items() {
! 		if ( !empty($this->in_footer) ) {
! 			foreach( $this->in_footer as $key => $handle ) {
! 				if ( !in_array($handle, $this->done, true) && isset($this->registered[$handle]) ) {
! 					$this->do_item($handle);
! 					$this->done[] = $handle;
! 					unset( $this->in_footer[$key] );
! 				}
! 			}
! 		}
  		return $this->done;
  	}
  
--- 179,185 ----
  	}
  
  	function do_footer_items() {
! 		$this->do_items(false, 1);
  		return $this->done;
  	}
  
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/class.wp-styles.php ./wordpress-3.3/wp-includes/class.wp-styles.php
*** ./wordpress-3.2.1/wp-includes/class.wp-styles.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/class.wp-styles.php	2011-07-28 13:24:00.000000000 -0500
***************
*** 25,30 ****
--- 25,31 ----
  	var $concat_version = '';
  	var $do_concat = false;
  	var $print_html = '';
+ 	var $print_code = '';
  	var $default_dirs;
  
  	function __construct() {
***************
*** 35,78 ****
  		if ( !parent::do_item($handle) )
  			return false;
  
! 		if ( null === $this->registered[$handle]->ver )
  			$ver = '';
  		else
! 			$ver = $this->registered[$handle]->ver ? $this->registered[$handle]->ver : $this->default_version;
  
  		if ( isset($this->args[$handle]) )
  			$ver = $ver ? $ver . '&amp;' . $this->args[$handle] : $this->args[$handle];
  
  		if ( $this->do_concat ) {
! 			if ( $this->in_default_dir($this->registered[$handle]->src) && !isset($this->registered[$handle]->extra['conditional']) && !isset($this->registered[$handle]->extra['alt']) ) {
  				$this->concat .= "$handle,";
  				$this->concat_version .= "$handle$ver";
  				return true;
  			}
  		}
  
! 		if ( isset($this->registered[$handle]->args) )
! 			$media = esc_attr( $this->registered[$handle]->args );
  		else
  			$media = 'all';
  
! 		$href = $this->_css_href( $this->registered[$handle]->src, $ver, $handle );
! 		$rel = isset($this->registered[$handle]->extra['alt']) && $this->registered[$handle]->extra['alt'] ? 'alternate stylesheet' : 'stylesheet';
! 		$title = isset($this->registered[$handle]->extra['title']) ? "title='" . esc_attr( $this->registered[$handle]->extra['title'] ) . "'" : '';
  
  		$end_cond = $tag = '';
! 		if ( isset($this->registered[$handle]->extra['conditional']) && $this->registered[$handle]->extra['conditional'] ) {
! 			$tag .= "<!--[if {$this->registered[$handle]->extra['conditional']}]>\n";
  			$end_cond = "<![endif]-->\n";
  		}
  
  		$tag .= apply_filters( 'style_loader_tag', "<link rel='$rel' id='$handle-css' $title href='$href' type='text/css' media='$media' />\n", $handle );
! 		if ( 'rtl' === $this->text_direction && isset($this->registered[$handle]->extra['rtl']) && $this->registered[$handle]->extra['rtl'] ) {
! 			if ( is_bool( $this->registered[$handle]->extra['rtl'] ) ) {
! 				$suffix = isset( $this->registered[$handle]->extra['suffix'] ) ? $this->registered[$handle]->extra['suffix'] : '';
! 				$rtl_href = str_replace( "{$suffix}.css", "-rtl{$suffix}.css", $this->_css_href( $this->registered[$handle]->src , $ver, "$handle-rtl" ));
  			} else {
! 				$rtl_href = $this->_css_href( $this->registered[$handle]->extra['rtl'], $ver, "$handle-rtl" );
  			}
  
  			$tag .= apply_filters( 'style_loader_tag', "<link rel='$rel' id='$handle-rtl-css' $title href='$rtl_href' type='text/css' media='$media' />\n", $handle );
--- 36,83 ----
  		if ( !parent::do_item($handle) )
  			return false;
  
! 		$obj = $this->registered[$handle];
! 		if ( null === $obj->ver )
  			$ver = '';
  		else
! 			$ver = $obj->ver ? $obj->ver : $this->default_version;
  
  		if ( isset($this->args[$handle]) )
  			$ver = $ver ? $ver . '&amp;' . $this->args[$handle] : $this->args[$handle];
  
  		if ( $this->do_concat ) {
! 			if ( $this->in_default_dir($obj->src) && !isset($obj->extra['conditional']) && !isset($obj->extra['alt']) ) {
  				$this->concat .= "$handle,";
  				$this->concat_version .= "$handle$ver";
+ 
+ 				$this->print_code .= $this->get_data( $handle, 'after' );
+ 
  				return true;
  			}
  		}
  
! 		if ( isset($obj->args) )
! 			$media = esc_attr( $obj->args );
  		else
  			$media = 'all';
  
! 		$href = $this->_css_href( $obj->src, $ver, $handle );
! 		$rel = isset($obj->extra['alt']) && $obj->extra['alt'] ? 'alternate stylesheet' : 'stylesheet';
! 		$title = isset($obj->extra['title']) ? "title='" . esc_attr( $obj->extra['title'] ) . "'" : '';
  
  		$end_cond = $tag = '';
! 		if ( isset($obj->extra['conditional']) && $obj->extra['conditional'] ) {
! 			$tag .= "<!--[if {$obj->extra['conditional']}]>\n";
  			$end_cond = "<![endif]-->\n";
  		}
  
  		$tag .= apply_filters( 'style_loader_tag', "<link rel='$rel' id='$handle-css' $title href='$href' type='text/css' media='$media' />\n", $handle );
! 		if ( 'rtl' === $this->text_direction && isset($obj->extra['rtl']) && $obj->extra['rtl'] ) {
! 			if ( is_bool( $obj->extra['rtl'] ) ) {
! 				$suffix = isset( $obj->extra['suffix'] ) ? $obj->extra['suffix'] : '';
! 				$rtl_href = str_replace( "{$suffix}.css", "-rtl{$suffix}.css", $this->_css_href( $obj->src , $ver, "$handle-rtl" ));
  			} else {
! 				$rtl_href = $this->_css_href( $obj->extra['rtl'], $ver, "$handle-rtl" );
  			}
  
  			$tag .= apply_filters( 'style_loader_tag', "<link rel='$rel' id='$handle-rtl-css' $title href='$rtl_href' type='text/css' media='$media' />\n", $handle );
***************
*** 80,95 ****
  
  		$tag .= $end_cond;
  
! 		if ( $this->do_concat )
  			$this->print_html .= $tag;
! 		else
  			echo $tag;
  
! 		// Could do something with $this->registered[$handle]->extra here to print out extra CSS rules
! //		echo "<style type='text/css'>\n";
! //		echo "/* <![CDATA[ */\n";
! //		echo "/* ]]> */\n";
! //		echo "</style>\n";
  
  		return true;
  	}
--- 85,128 ----
  
  		$tag .= $end_cond;
  
! 		if ( $this->do_concat ) {
  			$this->print_html .= $tag;
! 			$this->print_html .= $this->print_inline_style( $handle, false );
! 		} else {
  			echo $tag;
+ 			$this->print_inline_style( $handle );
+ 		}
+ 
+ 		return true;
+ 	}
+ 
+ 	function add_inline_style( $handle, $code ) {
+ 		if ( !$code )
+ 			return false;
+ 
+ 		$after = $this->get_data( $handle, 'after' );
+ 		if ( !$after )
+ 			$after = array();
  
! 		$after[] = $code;
! 
! 		return $this->add_data( $handle, 'after', $after );
! 	}
! 
! 	function print_inline_style( $handle, $echo = true ) {
! 		$output = $this->get_data( $handle, 'after' );
! 
! 		if ( empty( $output ) )
! 			return false;
! 
! 		$output = implode( "\n", $output );
! 
! 		if ( !$echo )
! 			return $output;
! 
! 		echo "<style type='text/css'>\n";
! 		echo "$output\n";
! 		echo "</style>\n";
  
  		return true;
  	}
***************
*** 123,126 ****
--- 156,171 ----
  		return false;
  	}
  
+ 	function do_footer_items() { // HTML 5 allows styles in the body, grab late enqueued items and output them in the footer.
+ 		$this->do_items(false, 1);
+ 		return $this->done;
+ 	}
+ 
+ 	function reset() {
+ 		$this->do_concat = false;
+ 		$this->concat = '';
+ 		$this->concat_version = '';
+ 		$this->print_html = '';
+ 	}
  }
+ 
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/class-wp-xmlrpc-server.php ./wordpress-3.3/wp-includes/class-wp-xmlrpc-server.php
*** ./wordpress-3.2.1/wp-includes/class-wp-xmlrpc-server.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/class-wp-xmlrpc-server.php	2011-10-27 13:36:49.000000000 -0500
***************
*** 8,14 ****
  /**
   * WordPress XMLRPC server implementation.
   *
!  * Implements compatability for Blogger API, MetaWeblog API, MovableType, and
   * pingback. Additional WordPress API for managing comments, pages, posts,
   * options, etc.
   *
--- 8,14 ----
  /**
   * WordPress XMLRPC server implementation.
   *
!  * Implements compatibility for Blogger API, MetaWeblog API, MovableType, and
   * pingback. Additional WordPress API for managing comments, pages, posts,
   * options, etc.
   *
***************
*** 234,242 ****
  
  		foreach ( (array) has_meta($post_id) as $meta ) {
  			// Don't expose protected fields.
! 			if ( strpos($meta['meta_key'], '_wp_') === 0 ) {
  				continue;
- 			}
  
  			$custom_fields[] = array(
  				"id"    => $meta['meta_id'],
--- 234,241 ----
  
  		foreach ( (array) has_meta($post_id) as $meta ) {
  			// Don't expose protected fields.
! 			if ( ! current_user_can( 'edit_post_meta', $post_id , $meta['meta_key'] ) )
  				continue;
  
  			$custom_fields[] = array(
  				"id"    => $meta['meta_id'],
***************
*** 262,279 ****
  		foreach ( (array) $fields as $meta ) {
  			if ( isset($meta['id']) ) {
  				$meta['id'] = (int) $meta['id'];
! 
  				if ( isset($meta['key']) ) {
! 					update_meta($meta['id'], $meta['key'], $meta['value']);
  				}
! 				else {
! 					delete_meta($meta['id']);
! 				}
! 			}
! 			else {
! 				$_POST['metakeyinput'] = $meta['key'];
! 				$_POST['metavalue'] = $meta['value'];
! 				add_meta($post_id);
  			}
  		}
  	}
--- 261,279 ----
  		foreach ( (array) $fields as $meta ) {
  			if ( isset($meta['id']) ) {
  				$meta['id'] = (int) $meta['id'];
! 				$pmeta = get_metadata_by_mid( 'post', $meta['id'] );
! 				$meta['value'] = stripslashes_deep( $meta['value'] );
  				if ( isset($meta['key']) ) {
! 					$meta['key'] = stripslashes( $meta['key'] );
! 					if ( $meta['key'] != $pmeta->meta_key )
! 						continue;
! 					if ( current_user_can( 'edit_post_meta', $post_id, $meta['key'] ) )
! 						update_metadata_by_mid( 'post', $meta['id'], $meta['value'] );
! 				} elseif ( current_user_can( 'delete_post_meta', $post_id, $pmeta->meta_key ) ) {
! 					delete_metadata_by_mid( 'post', $meta['id'] );
  				}
! 			} elseif ( current_user_can( 'add_post_meta', $post_id, stripslashes( $meta['key'] ) ) ) {
! 				add_post_meta( $post_id, $meta['key'], $meta['value'] );
  			}
  		}
  	}
***************
*** 527,533 ****
  				'wp_page_parent_id'		=> $page->post_parent,
  				'wp_page_parent_title'	=> $parent_title,
  				'wp_page_order'			=> $page->menu_order,
! 				'wp_author_id'			=> $author->ID,
  				'wp_author_display_name'	=> $author->display_name,
  				'date_created_gmt'		=> new IXR_Date($page_date_gmt),
  				'custom_fields'			=> $this->get_custom_fields($page_id),
--- 527,533 ----
  				'wp_page_parent_id'		=> $page->post_parent,
  				'wp_page_parent_title'	=> $parent_title,
  				'wp_page_order'			=> $page->menu_order,
! 				'wp_author_id'			=> (string) $author->ID,
  				'wp_author_display_name'	=> $author->display_name,
  				'date_created_gmt'		=> new IXR_Date($page_date_gmt),
  				'custom_fields'			=> $this->get_custom_fields($page_id),
***************
*** 747,753 ****
  			ORDER BY ID
  		");
  
! 		// The date needs to be formated properly.
  		$num_pages = count($page_list);
  		for ( $i = 0; $i < $num_pages; $i++ ) {
  			$post_date = mysql2date('Ymd\TH:i:s', $page_list[$i]->post_date, false);
--- 747,753 ----
  			ORDER BY ID
  		");
  
! 		// The date needs to be formatted properly.
  		$num_pages = count($page_list);
  		for ( $i = 0; $i < $num_pages; $i++ ) {
  			$post_date = mysql2date('Ymd\TH:i:s', $page_list[$i]->post_date, false);
***************
*** 1134,1147 ****
  		if ( !current_user_can( 'moderate_comments' ) )
  			return new IXR_Error( 403, __( 'You are not allowed to moderate comments on this site.' ) );
  
  		if ( !current_user_can( 'edit_comment', $comment_ID ) )
  			return new IXR_Error( 403, __( 'You are not allowed to moderate comments on this site.' ) );
  
  		do_action('xmlrpc_call', 'wp.deleteComment');
  
- 		if ( ! get_comment($comment_ID) )
- 			return new IXR_Error( 404, __( 'Invalid comment ID.' ) );
- 
  		return wp_delete_comment($comment_ID);
  	}
  
--- 1134,1147 ----
  		if ( !current_user_can( 'moderate_comments' ) )
  			return new IXR_Error( 403, __( 'You are not allowed to moderate comments on this site.' ) );
  
+ 		if ( ! get_comment($comment_ID) )
+ 			return new IXR_Error( 404, __( 'Invalid comment ID.' ) );
+ 
  		if ( !current_user_can( 'edit_comment', $comment_ID ) )
  			return new IXR_Error( 403, __( 'You are not allowed to moderate comments on this site.' ) );
  
  		do_action('xmlrpc_call', 'wp.deleteComment');
  
  		return wp_delete_comment($comment_ID);
  	}
  
***************
*** 1184,1197 ****
  		if ( !current_user_can( 'moderate_comments' ) )
  			return new IXR_Error( 403, __( 'You are not allowed to moderate comments on this site.' ) );
  
  		if ( !current_user_can( 'edit_comment', $comment_ID ) )
  			return new IXR_Error( 403, __( 'You are not allowed to moderate comments on this site.' ) );
  
  		do_action('xmlrpc_call', 'wp.editComment');
  
- 		if ( ! get_comment($comment_ID) )
- 			return new IXR_Error( 404, __( 'Invalid comment ID.' ) );
- 
  		if ( isset($content_struct['status']) ) {
  			$statuses = get_comment_statuses();
  			$statuses = array_keys($statuses);
--- 1184,1197 ----
  		if ( !current_user_can( 'moderate_comments' ) )
  			return new IXR_Error( 403, __( 'You are not allowed to moderate comments on this site.' ) );
  
+ 		if ( ! get_comment($comment_ID) )
+ 			return new IXR_Error( 404, __( 'Invalid comment ID.' ) );
+ 
  		if ( !current_user_can( 'edit_comment', $comment_ID ) )
  			return new IXR_Error( 403, __( 'You are not allowed to moderate comments on this site.' ) );
  
  		do_action('xmlrpc_call', 'wp.editComment');
  
  		if ( isset($content_struct['status']) ) {
  			$statuses = get_comment_statuses();
  			$statuses = array_keys($statuses);
***************
*** 1551,1557 ****
  	 *  - username
  	 *  - password
  	 *  - attachment_id
! 	 * @return array. Assocciative array containing:
  	 *  - 'date_created_gmt'
  	 *  - 'parent'
  	 *  - 'link'
--- 1551,1557 ----
  	 *  - username
  	 *  - password
  	 *  - attachment_id
! 	 * @return array. Associative array containing:
  	 *  - 'date_created_gmt'
  	 *  - 'parent'
  	 *  - 'link'
***************
*** 1661,1667 ****
  	}
  
  	/**
! 	  * Retrives a list of post formats used by the site
  	  *
  	  * @since 3.1
  	  *
--- 1661,1667 ----
  	}
  
  	/**
! 	  * Retrieves a list of post formats used by the site
  	  *
  	  * @since 3.1
  	  *
***************
*** 2394,2408 ****
  			}
  		}
  
- 		// We've got all the data -- post it:
  		$postdata = compact('post_author', 'post_date', 'post_date_gmt', 'post_content', 'post_title', 'post_category', 'post_status', 'post_excerpt', 'comment_status', 'ping_status', 'to_ping', 'post_type', 'post_name', 'post_password', 'post_parent', 'menu_order', 'tags_input', 'page_template');
  
! 		$post_ID = wp_insert_post($postdata, true);
! 		if ( is_wp_error( $post_ID ) )
! 			return new IXR_Error(500, $post_ID->get_error_message());
! 
! 		if ( !$post_ID )
! 			return new IXR_Error(500, __('Sorry, your entry could not be posted. Something wrong happened.'));
  
  		// Only posts can be sticky
  		if ( $post_type == 'post' && isset( $content_struct['sticky'] ) ) {
--- 2394,2402 ----
  			}
  		}
  
  		$postdata = compact('post_author', 'post_date', 'post_date_gmt', 'post_content', 'post_title', 'post_category', 'post_status', 'post_excerpt', 'comment_status', 'ping_status', 'to_ping', 'post_type', 'post_name', 'post_password', 'post_parent', 'menu_order', 'tags_input', 'page_template');
  
! 		$post_ID = $postdata['ID'] = get_default_post_to_edit( $post_type, true )->ID;
  
  		// Only posts can be sticky
  		if ( $post_type == 'post' && isset( $content_struct['sticky'] ) ) {
***************
*** 2426,2431 ****
--- 2420,2432 ----
  		if ( isset( $content_struct['wp_post_format'] ) )
  			wp_set_post_terms( $post_ID, array( 'post-format-' . $content_struct['wp_post_format'] ), 'post_format' );
  
+ 		$post_ID = wp_insert_post( $postdata, true );
+ 		if ( is_wp_error( $post_ID ) )
+ 			return new IXR_Error(500, $post_ID->get_error_message());
+ 
+ 		if ( !$post_ID )
+ 			return new IXR_Error(500, __('Sorry, your entry could not be posted. Something wrong happened.'));
+ 
  		logIO('O', "Posted ! ID: $post_ID");
  
  		return strval($post_ID);
***************
*** 2849,2855 ****
  				'mt_keywords' => $tagnames,
  				'wp_slug' => $postdata['post_name'],
  				'wp_password' => $postdata['post_password'],
! 				'wp_author_id' => $author->ID,
  				'wp_author_display_name'	=> $author->display_name,
  				'date_created_gmt' => new IXR_Date($post_date_gmt),
  				'post_status' => $postdata['post_status'],
--- 2850,2856 ----
  				'mt_keywords' => $tagnames,
  				'wp_slug' => $postdata['post_name'],
  				'wp_password' => $postdata['post_password'],
! 				'wp_author_id' => (string) $author->ID,
  				'wp_author_display_name'	=> $author->display_name,
  				'date_created_gmt' => new IXR_Date($post_date_gmt),
  				'post_status' => $postdata['post_status'],
***************
*** 2959,2965 ****
  				'mt_keywords' => $tagnames,
  				'wp_slug' => $entry['post_name'],
  				'wp_password' => $entry['post_password'],
! 				'wp_author_id' => $author->ID,
  				'wp_author_display_name' => $author->display_name,
  				'date_created_gmt' => new IXR_Date($post_date_gmt),
  				'post_status' => $entry['post_status'],
--- 2960,2966 ----
  				'mt_keywords' => $tagnames,
  				'wp_slug' => $entry['post_name'],
  				'wp_password' => $entry['post_password'],
! 				'wp_author_id' => (string) $author->ID,
  				'wp_author_display_name' => $author->display_name,
  				'date_created_gmt' => new IXR_Date($post_date_gmt),
  				'post_status' => $entry['post_status'],
***************
*** 3445,3451 ****
  		} elseif ( isset($urltest['fragment']) ) {
  			// an #anchor is there, it's either...
  			if ( intval($urltest['fragment']) ) {
! 				// ...an integer #XXXX (simpliest case)
  				$post_ID = (int) $urltest['fragment'];
  				$way = 'from the fragment (numeric)';
  			} elseif ( preg_match('/post-[0-9]+/',$urltest['fragment']) ) {
--- 3446,3452 ----
  		} elseif ( isset($urltest['fragment']) ) {
  			// an #anchor is there, it's either...
  			if ( intval($urltest['fragment']) ) {
! 				// ...an integer #XXXX (simplest case)
  				$post_ID = (int) $urltest['fragment'];
  				$way = 'from the fragment (numeric)';
  			} elseif ( preg_match('/post-[0-9]+/',$urltest['fragment']) ) {
